﻿package nl.prefab.guys.data
{
	import away3d.containers.ObjectContainer3D;
	import away3d.containers.Scene3D;
	import away3d.entities.Mesh;
	
	import flash.geom.Matrix3D;
	
	import nl.prefab.guys.Guy;
	
	public class PropertyData
	{
		private var _propertyName:String = "";
		private var _guy:Guy;
		private var _uniqueID:String;
		
		public function PropertyData(guy:Guy):void
		{
			_guy = guy;
			_uniqueID = Guy.getUniqueID("pd");
		}
		
		public function set name(val:String):void
		{
			_guy.restore();
			
			if(_propertyName != "" && _propertyName != val)
				_guy.updateOriginalSettings(this, val);
			
			_propertyName = val;
		}
		
		//read only
		public function get name():String
		{
			return _propertyName;
		}
		public function get uniqueID():String
		{
			return _uniqueID;
		}
		
		//active
		public var active:Boolean = true;
		public var restored:Boolean;
		
		// in sequence
		public var sequence:Boolean;
		
		//linear
		public var value:Number;
		public var updateValue:Number;
		public var loop:Boolean;
		public var maxValue:Number = Number.MAX_VALUE;
		public var minValue:Number = Number.MIN_VALUE;
		//tweens
		//state = 0:has tweened, 1:to be tweened
		public var state:uint;
		public var reverse:Boolean;
		public var playReverse:Boolean;
		public var destValue:Number;
		public var destTime:Number;
		public var currentTime:Number;
		public var duration:Number;
		public var easingMethod:Function;
		public var easingMethodIndex:uint;
		public var frame:uint;
		//lookat
		public var lookAtObject:Object;
		//follow
		public var range:Number;
		public var distance:Number;
		//data
		public var data:Object;
		public var ghostId:String;
		public var scene:Scene3D;
		public var transform:Matrix3D;
		
		//editors
		public var debugGeometry:ObjectContainer3D;
		public var mesh:Mesh;
		

	}
}