﻿//Prefab3D. www.closier.nl/prefab .  Fabrice Closier 2012

package nl.prefab.guys.types
{
	import nl.prefab.guys.Guy;
	import nl.prefab.guys.data.PropertyData;
	import nl.prefab.guys.data.GuysTypes;
	 
	import away3d.entities.Mesh;
	import away3d.containers.Scene3D;
	
	import flash.geom.Matrix3D;
	
	public class DataGuy extends Guy{
		//a single var as dataGuy is not shared
		private var _propertyData:PropertyData;
		private var _mesh:Mesh;
		
		public function DataGuy(id:String){
			super(id, GuysTypes.DATA, false);
		}
		
		//no updates required
		public override function update():void{}
		 
		public function addProperty(name:String, data:Object = null, mesh:Mesh = null, scene:Scene3D = null, rawData:Vector.<Number> = null ):PropertyData 
		{
			if(_propertyData) _propertyData = null;
			
			_propertyData = new PropertyData(this);
			_propertyData.name = name;
			_propertyData.data = data;
			_propertyData.mesh = _mesh = mesh;
			_propertyData.scene = scene;
			
			if(rawData) _propertyData.transform = new Matrix3D(rawData);
			
			//build(propertyData);
			//no need to register this guy
			//addPropertyData(_propertyData);
			 
			return _propertyData;
		}
		
		public function build():void
		{
			if(_mesh){
				var guyMesh:Mesh = new Mesh(_mesh.geometry.clone(), _mesh.material);
				
				if(_propertyData.transform)
					guyMesh.transform = _propertyData.transform;
				
				if(_propertyData.scene)
					_propertyData.scene.addChild(guyMesh);
				
				_propertyData.mesh = guyMesh;
				
			} else {
				trace("DataGuy "+this.id+" cannot find the referenced mesh. Make sure that the mesh exists before call the build method.");
			}

		}
		
	}
}