﻿//Prefab3D. www.closier.nl/prefab .  Fabrice Closier 2012

package nl.prefab.guys.types
{
	import nl.prefab.guys.Guy;
	import nl.prefab.guys.data.PropertyData;
	import nl.prefab.guys.data.GuysTypes;
	
	import away3d.core.base.Object3D;
	import away3d.containers.ObjectContainer3D;
	import away3d.entities.Mesh;
	
	import flash.geom.Vector3D;
	import flash.utils.getTimer;
	
	public class LookAtGuy extends Guy
	{
		public function LookAtGuy(id:String){
			super(id, GuysTypes.ANIMATION_LOOKAT, false);
		}
  
		public override function update():void
		{
			var property:PropertyData;
			var obj:Object;
			var j:uint;

			for(var i:uint = 0;i<properties.length;++i){
				property = properties[i];
				
				for(j = 0;j<targets.length;++j){
					 
					obj = targets[j].object;
					if(!obj || !property.lookAtObject || property.lookAtObject == obj) continue;
					
					if(property.lookAtObject is ObjectContainer3D || property.lookAtObject is Mesh){
						Object3D(obj).lookAt(property.lookAtObject.position);
					} else if(property.lookAtObject is Vector3D){
						Object3D(obj).lookAt(Vector3D(property.lookAtObject));
					}
				}
			}
		}
		
		public function addProperty(lookAtObject:Object):PropertyData 
		{
			var propertyData:PropertyData = new PropertyData(this);
			propertyData.name = "lookatguy"+getTimer();
			propertyData.lookAtObject = lookAtObject;
			
			addPropertyData(propertyData);
			 
			return propertyData;
		}
		
	}
}