﻿//Prefab3D. www.closier.nl/prefab .  Fabrice Closier 2012

package nl.prefab.guys.types
{
	import nl.prefab.guys.Guy;
	import nl.prefab.guys.data.PropertyData;
	import nl.prefab.guys.data.GuysTypes;
	import nl.prefab.guys.events.GuyEvent;
	
	import away3d.core.base.Object3D;
	
	import flash.utils.getTimer;
	
	public class RandomGuy extends Guy
	{
		public function RandomGuy(id:String){
			super(id, GuysTypes.ANIMATION_RANDOM, true);
		}
  
		public override function update():void
		{
			var property:PropertyData;
			var obj:Object;
			var j:uint;
			var k:uint;
			var val:Number;
			var propertyRestored:Boolean;
			var nowTime:int = getTimer();

			for(var i:uint = 0;i<properties.length;++i){
				property = properties[i];
				if(!property.active) continue;
				
				propertyRestored = property.restored;
				
				if(propertyRestored && !isNaN(property.value) ){
					property.currentTime = 0;
					dispatchGuyEvent(GuyEvent.RESET, property);
				}
				
				for(j = 0;j<targets.length;++j){
					 
					obj = targets[j].object;
					if(!obj) continue;
					
					if(nowTime-property.currentTime < property.duration) continue;
					
					property.currentTime = nowTime;
					
					val = property.minValue + Math.random()*property.maxValue;
					
					obj[property.name] = val;
				}
			}
		}
		
		public function addProperty(name:String, minValue:Number, maxValue:Number, duration:uint = 250):PropertyData 
		{
			var propertyData:PropertyData = new PropertyData(this);
			propertyData.name = name;
			propertyData.minValue = Math.min(minValue, maxValue);
			propertyData.maxValue = Math.max(minValue, maxValue);
			propertyData.currentTime = 0;
			propertyData.duration = duration;
			
			if(propertyData.minValue<0){
				propertyData.maxValue += Math.abs(propertyData.minValue);
			}else{
				propertyData.maxValue -= propertyData.minValue;
			}
			
			addPropertyData(propertyData);
			 
			return propertyData;
		}
		
	}
}